unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Label1: TLabel;
    Button1: TButton;
    ReplaceDialog1: TReplaceDialog;
    procedure Button1Click(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  p: Integer; // ,     

procedure TForm1.Button1Click(Sender: TObject);
begin
  p:=1; //   :   
  ReplaceDialog1.Execute;
end;

procedure TForm1.ReplaceDialog1Find(Sender: TObject);
var
  SelPos: Integer;
begin
  //     
  SelPos := Pos(ReplaceDialog1.FindText,
                Copy(Memo1.Lines.Text,p,Length(Memo1.Lines.Text)-p+1));
  if SelPos > 0 then
  begin
    //   -  
    Memo1.SelStart := SelPos + p - 2;
    Memo1.SelLength := Length(ReplaceDialog1.FindText);
    //   ,   !!!
    Memo1.SetFocus;
    p:=p + SelPos; //    
  end
    else
      ShowMessage(' "' + ReplaceDialog1.FindText + '"  !');
end;


procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
var
  SelPos: Integer;
begin
  // ,    " "
  if frReplaceAll in ReplaceDialog1.Options then
  begin //  -     
    SelPos := Pos(ReplaceDialog1.FindText,Memo1.Lines.Text);
    while SelPos>0 do
    begin
      Memo1.Lines.Text:=
          //      ,
          Copy(Memo1.Lines.Text,1,SelPos-1)+
          //    
          ReplaceDialog1.ReplaceText +
          //     .
          Copy(Memo1.Lines.Text,
               SelPos + Length(ReplaceDialog1.FindText),
               Length(Memo1.Lines.Text)-SelPos + Length(ReplaceDialog1.FindText));
      SelPos := Pos(ReplaceDialog1.FindText,Memo1.Lines.Text);
    end
  end
  else //   ""
    if Memo1.SelText <> '' then  //     -   
        Memo1.SelText := ReplaceDialog1.ReplaceText;
end;

end.
